=== debian/changelog ===
wxpython4.0 (4.0.7+dfsg-6) unstable; urgency=medium

  * Get unittests working again
  * Backport update of InitLocale() to fix test hangs

 -- Scott Talbert <swt@techie.net>  Wed, 15 Jul 2020 11:12:24 -0400

wxpython4.0 (4.0.7+dfsg-5) unstable; urgency=medium

  * Update debhelper-compat to 13
  * Add wxpython-tools subpackage to replace python-wxtools from wxpython3.0

 -- Scott Talbert <swt@techie.net>  Mon, 29 Jun 2020 20:08:58 -0400

wxpython4.0 (4.0.7+dfsg-4) unstable; urgency=medium

  * Fix FTBFS with SIP 4.19.23 (Closes: #963283)
  * Update Standards Version to 4.5.0

 -- Scott Talbert <swt@techie.net>  Sun, 21 Jun 2020 20:47:56 -0400

wxpython4.0 (4.0.7+dfsg-3) unstable; urgency=medium

  * Add missing TreeCtrl SetSpacing / GetSpacing methods

 -- Scott Talbert <swt@techie.net>  Tue, 14 Apr 2020 21:11:48 -0400

wxpython4.0 (4.0.7+dfsg-2) unstable; urgency=medium

  * Fix SyntaxWarnings (Closes: #945052)

 -- Scott Talbert <swt@techie.net>  Sun, 24 Nov 2019 10:25:09 -0500

wxpython4.0 (4.0.7+dfsg-1) unstable; urgency=medium

  * Update to new upstream release 4.0.7
  * d/patches: remove support-pathlib-and-pathlib2.patch -> no longer needed
  * d/patches: update unbundle-sip.patch
  * d/control: Update Standards Version to 4.4.1

 -- Scott Talbert <swt@techie.net>  Tue, 29 Oct 2019 20:42:52 -0400
